
//	Copyright 2010 PaletteSoft LLC

// ***************************************************************************
// *	dl															 *
// ***************************************************************************
/*
	_Ci~bNTv@̂Q	PIC12F683	CLOCK:INTRCIO/4MHz

	GP0:LEDx	gݍ킹
	GP1:LEDy	gݍ킹
	GP2:LEDz	gݍ킹
	GP3:MCLR	-----
	GP4:---		gpivAbvpj
	GP5:---		gpivAbvpj

	R̏o̓|[g𗘗pĂU̂kdc𐧌䂷BvŹui|Pjv

			LED0	LED1	LED2	LED3	LED4	LED5
	LEDx	H		L		HIZ		HIZ		H		L
	LEDy	L		H		H		L		HIZ		HIZ
	LEDz	HIZ		HIZ		L		H		L		H

	H/L͏o̓|[gł̉^pB
	HIZ͓̓|[gł̉^pB̎AvAbv͖
	S_A_͍\sBSLLLƂB

	_Ci~bŃA
	EFPQiQOSWʂUubNj
	E_䗦FPUDViP^Uj

	uNA
	EkdcOAkdcPckdcTƂPbƂɂP_Ȃړ
	ES
	EkdcTAkdcSckdcOƂPbƂɂP_Ȃړ
	ES
	EkdcO瓯_P₵AU𓯎_
	ES
	EU𓯎_kdcO瓯_P炷
	ES
	EŏJԂ

	^C}͓^C}O𗘗pA荞ݏŃ_Ci~bNȂB
*/

// ***************************************************************************
// *	CN[ht@C												 *
// ***************************************************************************

#include	<pic.h>														//	vWFNgݒőIꂽfoCXIɈp܂

#include	<string.h>													//	񑀍n

#include	"_AtrDef.h"													//	萔Af[^^̐錾

// ***************************************************************************
// *	vOo[W												 *
// ***************************************************************************

#define	VER1					0										//	ʏ\̈	PŎwip֎~j
#define	VER2					2										//	ʈ̈	PŎwip֎~j
//								.
#define	VER3					0										//	ʏ\̈	PŎwip֎~j
#define	VER4					1										//	ʈ̈	PŎwip֎~j	|[gC

#define	COPYRIGHT				"Copyright 2010 PaletteSoft LLC"		//	쌠

// ***************************************************************************
// *																 *
// ***************************************************************************

	//	*****  *****

__CONFIG(	FCMDIS														//	tF[Z[tNbNj^֎~
		&	IESODIS														//	ONbÑXCb`I[o[[h֎~
		&	BORDIS														//	uEAEgo֎~
		&	UNPROTECT													//	f[^iEEPROMj̃veNg֎~
		&	UNPROTECT													//	vÕveNg֎~
		&	MCLREN														//	GP3/_MCLR[q_MCLRŗpiIɃvAbvj
		&	PWRTEN														//	p[Abv^C}싖
		&	WDTDIS														//	EHb`hbO^C}֎~
		&	INTIO														//	NbNpRA4ARA5[q͓o͂ŗp
);

	//	***** hc *****

__IDLOC7(VER1, VER2, VER3, VER4);										//	o[WԍƂĒ`ïӖt͔CӁj

	//	***** U *****

#define	_XTAL_FREQ				4000000									//	gigj		c@__delay_XXňp

// ***************************************************************************
// *	f[^^															 *
// ***************************************************************************

	//	***** kdc̐ *****

typedef	struct {
	_UB		GPIO;														//	o̓f[^				c@volatileɒ
	_UB		TRISIO;														//	f[^				c@volatileɒ
} sLedDyn;

// ***************************************************************************
// *	Œl																 *
// ***************************************************************************

	//	***** kdc *****

enum {																	//	kdcԍ̒`
	LED_0,	LED_1,	LED_2,	LED_3,	LED_4,	LED_5,						//	eV{ɂ͂O`T蓖Ă܂
	LED_TOTAL															//	kdc
};

	//	***** _Ci~bN *****

#define	DYN_TOTAL				(LED_TOTAL)								//	_Ci~bN̏񐔁c@ʂƂĂkdcɓǏ͕ʕ

	//	*****  *****

#define	TIME_SEC				(1000000L / 2048L)						//	b̊i͏_ȉ؂̂āj

// ***************************************************************************
// *	O[oϐ														 *
// ***************************************************************************

UB		vPortData;														//	o̓|[g̃obNAbv
UB		vPortDir;														//	|[gõ͕obNAbv

UB		vLedStep;														//	kdcڈʒu
sLedDyn	vLedCtrl[DYN_TOTAL];											//	kdcC[Wi_Ci~bN䕪pӁj

UH		vTimeCount;														//	^CAEgopJE^
BIT		vTimeoutFlag;													//	^CAEgtO

// ***************************************************************************
// *	e[u															 *
// ***************************************************************************

	//	***** ʂkdc *****

const	sLedDyn		cLedDyn[LED_TOTAL] = {
//		GPIO  	TRISIO																	LEDz(GP2)	LEDy(GP1)	LEDx(GP0)	c@rbǧɒ
	{	0b001,	0b100	},												//	kdcO	HIZ			L			H			c@foOkra
	{	0b010,	0b100	},												//	kdcP	HIZ			H			L
	{	0b010,	0b001	},												//	kdcQ	L			H			HIZ
	{	0b100,	0b001	},												//	kdcR	H			L			HIZ
	{	0b001,	0b010	},												//	kdcS	L			HIZ			H
	{	0b100,	0b010	},												//	kdcT	H			HIZ			L
};
//					  76543210
#define	IO_MASK		0b00000111											//	̃}XNf[^ikdc蓖ĂĂӏɒځj

	//	***** \f[^ *****

const	UB		tDispData[] = {
//	  543210															//	OPQRST
	0b000001,															//		O
	0b000010,															//		P
	0b000100,															//		Q
	0b001000,															//		R
	0b010000,															//		S
	0b100000,															//		T
	0b000000,															//		U

//	  543210															//	OPQRST
	0b100000,															//		O
	0b010000,															//		P
	0b001000,															//		Q
	0b000100,															//		R
	0b000010,															//		S
	0b000001,															//		T
	0b000000,															//		U

//	  543210															//	OPQRST
	0b000001,															//		O
	0b000011,															//		P
	0b000111,															//		Q
	0b001111,															//		R
	0b011111,															//		S
	0b111111,															//		T
	0b000000,															//		U

//	  543210															//	OPQRST
	0b111111,															//		O
	0b111110,															//		P
	0b111100,															//		Q
	0b111000,															//		R
	0b110000,															//		S
	0b100000,															//		T
	0b000000,															//		U
};

// ***************************************************************************
// *	}N錾															 *
// ***************************************************************************


// ***************************************************************************
// *	vg^Cv錾													 *
// ***************************************************************************

	//	***** }lWg *****

BOOL	MngChkTimeout(void);
void	MngCnvImage(UB Image);

	//	***** foCX *****

void	DevInit(void);

	//	***** ^C} *****

void	TmInit(void);

// ***************************************************************************
// *	{															 *
// ***************************************************************************

//	
//	
//
// 		}lWg
//
//	
//	
void	Mng______(void) {}												//	op֐

//============================================================================
//	C
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	X^[gAbv[`̃Wv߂ŌĂяo܂B
//			{֐͖[vłAEo邱Ƃ͂܂B
//============================================================================
void	main(void)
{
	UB		DispStep;													//	\Xebv

	//	***** ͂߂ *****

	di();																//	Ă̊荞݋֎~𖾎

	DevInit();															//	foCXݒ
	TmInit();															//	^C}ݒ

	//	***** _Ci~bN̏ݒ *****

	vLedStep = 0;														//	ڈʒu擪

	memset(vLedCtrl, 0x00, sizeof(vLedCtrl));							//	C[W͑ď	c@Zbg֐ĂԂƊ荞݋邩ʖڂ

	//	***** ^p̏ݒ *****

	vTimeCount = 0;														//	^CAEgopJE^NA
	vTimeoutFlag = 0;													//	^CAEgĂȂ

	//	***** 荞݋N *****

	T0IE = 1;															//	^C}O
	ei();																//	荞݋

	//	*****  *****

	DispStep = 0;														//	\Xebv擪

	while (1) {															//	[vł

		//	***** ^C~Off *****

		if (MngChkTimeout()) {											//	^C~OoH

			//	***** Tv\ *****

			MngCnvImage(tDispData[DispStep]);							//	\C[W擾ĐC[Wɕϊ

			if (++DispStep >= sizeof(tDispData)) {						//	\C[W̃f[^𑍂ēǂݏoH
				DispStep = 0;											//	\Xebv擪
			}
		}

/*
		ŕʂ̋@\蓖Ăo̓|[g̑邱Ƃł܂A
		kdc|[gƓ̃|[gANZXꍇ̓obNAbvp
		ϐ𑀍삵Ăo͂邾łȂA荞݋֎~삪KvłB
*/

	}
}

//============================================================================
//	^C~OmF
//----------------------------------------------------------------------------
//	́F	
//	óF	^CAEgԁiOF^CAEgĂȂAOF^CAEgj
//----------------------------------------------------------------------------
//	lF	C̐^C~Oł邩ۂff܂B
//============================================================================
BOOL	MngChkTimeout(void)
{
	UB		Result = 0;													//	^CAEgĂȂ

	di();																//	荞݋֎~			c@ꔭ߂ŏȂ疳Ăv

	if (vTimeoutFlag) {													//	^CAEgoH
		vTimeoutFlag = 0;												//	o
		Result ++;														//	^CAEg܂	c@RpCɔRBȂ
//*		Result = 1;														//	^CAEg܂	c@RpCɕĂd܂񂪁i
	}

	ei();																//	荞݋			c@荞݋֎~ɂ͕Kv

	return(Result);														//	߂lԂĂ܂
}

//============================================================================
//	kdcC[W
//----------------------------------------------------------------------------
//	́F	\C[W
//	óF	
//----------------------------------------------------------------------------
//	lF	͂\C[WkdcC[Wɐ܂B
//			C[WXVɂ荞ݏ琧C[WQƂ܂
//			_Ci~bN̂̃W}łB
//			ėp֐Ȃ̂ŕ\C[W𑍂ēWJĂ܂B
//============================================================================
void	MngCnvImage(UB Image)
{
	UB		TargetLed;													//	kdc̒ڈʒu
	UB		Loop;														//	[vJE^
	sLedDyn	Control;													//	f[^̍Ɨp

	sLedDyn	*Pointer;													//	C[Ww|C^

	//	***** ͂߂ *****

	TargetLed = (UB)BIT00;												//	kdcO𒍖
	Pointer = vLedCtrl;													//	C[W̐擪|CgĂi荞݋֎~̒ł̉Z炷j

	//	***** _Ci~bN䏄 *****

	for (Loop=0; Loop<DYN_TOTAL; Loop++) {								//	_Ci~bN䏄񐔕܂܂	c@䏄񐔂Ƃkdc͕KvȂ

		//	***** C[W̏ *****

		if (Image & TargetLed) {										//	ڂkdc͓_H
			Control.GPIO   = cLedDyn[Loop].GPIO;						//	o̓f[^F_p
			Control.TRISIO = cLedDyn[Loop].TRISIO;						//	f[^F_p
		}
		else {															//	ڂkdc͏
			Control.GPIO   = 0b000;										//	o̓f[^Fp
			Control.TRISIO = 0b000;										//	f[^Fp
		}

		//	***** C[W̔f *****

		di();															//	P̐ɑ΂ăZbgƂȂ񂪂̂Ŋ荞݋֎~ňꊇXV

		Pointer->GPIO   = Control.GPIO;									//	o̓f[^ۑ
		Pointer->TRISIO = Control.TRISIO;								//	f[^ۑ

		ei();															//	荞݋

		//	***** ̐ꏊ *****

		TargetLed <<= 1;												//	kdc̒ڈʒuXV
		Pointer ++;														//	̐C[W
	}
}

//============================================================================
//	荞
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	荞ݏłB^C}O̊荞݂Ă܂B
//			UiSlgjWĂ̂ŁA͂QOSWʂłB
//
//			͊荞ݏ̒ŕ\C[W琧f[^쐬Ă܂
//			ACŐf[^obt@Ɋi[@\łB
//			O҂̏ꍇ͕ϐ̐ߖA҂̏ꍇ͏Ԃ̐ߖ}܂B
//			ǂ炩Ƃƌ҂D݂łATvƂƂŌéB
//============================================================================
void	interrupt	ipt(void)
{
	//	***** 荞ݗv̊mF *****

	if (T0IF) {															//	^C}OvH		c@LɂĂ̂͂PȂ̂Łc@@ƂĖ
		T0IF = 0;														//	^C}Ov

		//	***** kdcf[^쐬 *****							//	obt@ɍ\zς݂̕\ׂe𔽉f

		vPortData = (vPortData & ~IO_MASK) | vLedCtrl[vLedStep].GPIO;	//	o̓f[^					c@kdcȊO͕̊ێ
		vPortDir  = (vPortDir  & ~IO_MASK) | vLedCtrl[vLedStep].TRISIO;	//	f[^

		//	***** kdc\~ *****

		GPIO	= vPortData & ~IO_MASK;									//	kdc_Ԃ		c@r[ȓ_݂̍邽߁i厖j

		//	***** kdc\XV *****									//	荞݃^C~Oɑ΂Ăkdc\XV^C~O͈肷͂

		TRISIO	= vPortDir;												//	f[^Zbg
		GPIO	= vPortData;											//	o̓f[^Zbg			c@ő_kdc_

		//	***** ڈʒuXV *****

		vLedStep ++;													//	ڈʒu{P

		if (vLedStep >= LED_TOTAL) {									//	ĂH
			vLedStep = 0;												//	ڈʒu擪ɖ߂
		}

		//	***** PbZo *****

		if (++vTimeCount >= (UH)TIME_SEC) {								//	Pbo߁H
			vTimeCount = 0;												//	ŏ
			vTimeoutFlag = 1;											//	^CAEgZbg
		}
	}
}

//	
//	
//
// 		foCX
//
//	
//	
void	Dev______(void) {}												//	op֐

//============================================================================
//	foCXݒ
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	foCX̏ݒs܂B
//			Zbg̏lōςޏꍇ͍Đݒ肵Ă܂B
//============================================================================
void	DevInit(void)
{
	//	***** { *****

//						  76543210
	OPTION =			0b01111111;										//	IvVWX^
																		//	bit07:GPPU		0	̓|[g̃vAbv			
																		//	bit06:INTEDG	1	O荞݂͗オGbW		gp
																		//	bit05:T0CS		1	^C}O͊ONbN𗘗p		gp
																		//	bit04:T0SE		1	^C}O̍XV͗GbW		gp
																		//	bit03:PSA		1	vXP[͂vcsŗp			gp
																		//	bit02:PS2		1	vXP[͂PQW			gp
																		//	bit01:PS1		1		ij
																		//	bit00:PS0		1		ij

	//	***** o̓|[g *****										//	ӁFĂ̏ꍇAėpo̓|[g͕ʋ@\Ă

//						  76543210
	vPortData		 =	0b00000000;										//	ėpo̓|[gf[^̏l
																		//	bit07:-----		0
																		//	bit06:-----		0
																		//	bit05:GP5		0	́FHHH						͂Ȃ̂ŖӖ
																		//	bit04:GP4		0	́FHHH						͂Ȃ̂ŖӖ
																		//	bit03:GP3		0	́Flbkq						w͖
																		//	bit02:GP2		0	óFkdc						
																		//	bit01:GP1		0	óFkdc						
																		//	bit00:GP0		0	óFkdc						

	GPIO = vPortData;													//	o̓|[gꊇҏW	c@rbgɂRead&ModifysȂ@

//						  76543210
	CMCON0 =			0b00000111;										//	Rp[^
																		//	bit07:-----		0
																		//	bit06:COUT		0	Rp[^o͏				ǂݏô݉
																		//	bit05:-----		0
																		//	bit04:CINV		0	o͔]Ȃ						gp
																		//	bit03:CIS		0	̓XCb`ݒ					gp
																		//	bit02:CM2		1	Rp[^It					
																		//	bit01:CM1		1		ij						
																		//	bit00:CM0		1		ij						

//						  76543210
	ANSEL =				0b00000000;										//	AiOZN^
																		//	bit07:-----		0
																		//	bit06:ADCS2		0	`cϊNbNI				gp
																		//	bit05:ADCS1		0		ij
																		//	bit04:ADCS0		0		ij
																		//	bit03:ANS3		0	`mRgpAfoSėpo		
																		//	bit02:ANS2		0	`mQgpAfoQėpo		
																		//	bit01:ANS1		0	`mPgpAfoPėpo		
																		//	bit00:ANS0		0	`mOgpAfoOėpo		

//						  76543210
	vPortDir =			0b00111000;										//	ėpo̓|[g
																		//	bit07:-----		0
																		//	bit06:-----		0
																		//	bit05:GP5		1	́FHHH						
																		//	bit04:GP4		1	́FHHH						
																		//	bit03:GP3		1	́Flbkq						ǂݏô݉
																		//	bit02:GP2		0	óFkdc						
																		//	bit01:GP1		0	óFkdc						
																		//	bit00:GP0		0	óFkdc						

	TRISIO = vPortDir;													//	o͕ꊇҏW
}

//	
//	
//
// 		^C}
//
//	
//	
void	Tm______(void) {}												//	op֐

//============================================================================
//	ݒ
//----------------------------------------------------------------------------
//	́F	
//	óF	
//----------------------------------------------------------------------------
//	lF	^C}Ȍݒs܂B
//============================================================================
void	TmInit(void)
{
	//	***** ^C}Õ[hݒ *****

	CLRWDT();															//	vcs̃tbV	c@ʓIɓ삵ĂȂ̂Ōʖ
																		//								f[^V[gɋLڂĂ@𓥏P
//						 76543210	   76543210
	OPTION = (OPTION & 0b11010000) | 0b00000010;						//	IvVWX^		c@ݒς݂̒lC
																		//	bit07:GPPU		*	iύXȂj
																		//	bit06:INTEDG	*	iύXȂj
																		//	bit05:T0CS		0	^C}O͓NbN𗘗p		
																		//	bit04:T0SE		*	iύXȂj
																		//	bit03:PSA		0	vXP[̓^C}Oŗp		
																		//	bit02:PS2		0	vXP[͂W				
																		//	bit01:PS1		1		ij
																		//	bit00:PS0		0		ij

	//	***** ^C}Õ^CAEg󋵂 *****

	TMR0 = 0;															//	^C}OJE^̃NAivXP[ɃNAj
	T0IE = 0;															//	^C}O͋֎~
	T0IF = 0;															//	^C}Ov	c@slqOWX^̃I[o[t[
}

// ***************************************************************************
// ***************************************************************************
// *																		 *
// ***************************************************************************
// ***************************************************************************

//	Copyright 2010 PaletteSoft LLC

